apiVersion: v1
kind: Template
labels:
  app: elasticsearch
  template: elasticsearch-buildconfig-with-secret
metadata:
  annotations:
    description: ElasticSearch database - BuildConfig with Secret
    iconClass: icon-openshift
    openshift.io/display-name: ElasticSearch
    tags: elasticsearch
  name: elasticsearch-buildconfig-with-secret
objects:
- apiVersion: v1
  kind: Secret
  metadata:
    annotations:
      template.openshift.io/expose-username: "{.data['username']}"
    name: git-elasticsearch-${ELASTICSEARCH_REPOSITORY_REF}
  stringData:
    username: "${GIT_DEPLOYMENT_TOKEN}"
- apiVersion: v1
  kind: BuildConfig
  metadata:
    annotations:
      description: Builds ElasticSearch images
    labels:
      name: elasticsearch-${ELASTICSEARCH_REPOSITORY_REF}
    name: elasticsearch-${ELASTICSEARCH_REPOSITORY_REF}
  spec:
    failedBuildsHistoryLimit: 1
    resources:
      limits:
        cpu: 300m
        memory: 1536Mi
    source:
      contextDir: /
      git:
        uri: ${ELASTICSEARCH_REPOSITORY_URL}
        ref: "${ELASTICSEARCH_REPOSITORY_REF}"
      sourceSecret:
        name: git-elasticsearch-${ELASTICSEARCH_REPOSITORY_REF}
      type: Git
    strategy:
      type: Docker
      dockerStrategy:
        env:
        - name: DO_UPGRADE
          value: foo
        forcePull: false
        from:
          kind: ImageStreamTag
          name: ${JAVA_IMAGESTREAM_TAG}
    output:
      to:
        kind: ImageStreamTag
        name: elasticsearch:${ELASTICSEARCH_REPOSITORY_REF}
    triggers:
    - type: ConfigChange
    - type: ImageChange
parameters:
- name: ELASTICSEARCH_REPOSITORY_REF
  description: Set this to a branch name, tag or other ref of your repository if you are not using the default branch
  displayName: Git Reference
  required: true
  value: master
- name: ELASTICSEARCH_REPOSITORY_URL
  description: The URL of the repository with your elasticsearch Dockerfile
  displayName: Git Repository URL
  required: true
  value: https://gitlab.com/synacksynack/opsperator/docker-elasticsearch.git
- name: GIT_DEPLOYMENT_TOKEN
  description: Git deployment token
  displayName: Git Deployment Token
  required: true
- name: JAVA_IMAGESTREAM_TAG
  description: Set this to Java ImageStream tag serving as base for ElasticSearch BuildConfig
  displayName: Java ImageStream Tag
  required: true
  value: java:master
